! This subroutine sets all couplings relevant for hadronic boson decays

      SUBROUTINE coupl_haddecay

      implicit none

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/process.inc"

      ! set all couplings as for leptonic decays
      GWP_ZUN(1) = GZN(1)
      GWP_ZUN(2) = GZN(2)
      GWP_ZDL(1) = GZL(1)
      GWP_ZDL(2) = GZL(2)
      GWP_AUN(1) = dcmplx(0.)
      GWP_AUN(2) = dcmplx(0.)
      GWP_ADL(1) = GAL(1)
      GWP_ADL(2) = GAL(2)
      GWM_ZUN(1) = GZN(1)
      GWM_ZUN(2) = GZN(2)
      GWM_ZDL(1) = GZL(1)
      GWM_ZDL(2) = GZL(2)
      GWM_AUN(1) = dcmplx(0.)
      GWM_AUN(2) = dcmplx(0.)
      GWM_ADL(1) = GAL(1)
      GWM_ADL(2) = GAL(2)
      GZ_ZF(1) = GZL(1)
      GZ_ZF(2) = GZL(2)
      GZ_ZUN(1) = GZN(1)
      GZ_ZUN(2) = GZN(2)
      GZ_AF(1) = GAL(1)
      GZ_AF(2) = GAL(2)
      Ztouu = .false.
      Ztodd = .false.

      SELECT CASE(procid)
      CASE(WPhadWMlep,GFWPhadWMlep,WPhadZ,
     &     WPhadWMjj, WPhadZjj, WPhadWMZ, ZZWPhad, WPhadWMWP, WMWPhadWM, WPhadZJ)
        ! set couplings for W+ hadronic decay
        GWP_ZUN(1) = GZU(1)
        GWP_ZUN(2) = GZU(2)
        GWP_ZDL(1) = GZD(1)
        GWP_ZDL(2) = GZD(2)
        GWP_AUN(1) = GAU(1)
        GWP_AUN(2) = GAU(2)
        GWP_ADL(1) = GAD(1)
        GWP_ADL(2) = GAD(2)
      CASE(WPlepWMhad,GFWPlepWMhad,WMhadZ,
     &     WPWMhadjj, WMhadZjj, WPWMhadZ, ZZWMhad, WPWMhadWP, WMhadWPWM, WMhadZJ)
        ! set couplings for W- hadronic decay
        GWM_ZUN(1) = GZU(1)
        GWM_ZUN(2) = GZU(2)
        GWM_ZDL(1) = GZD(1)
        GWM_ZDL(2) = GZD(2)
        GWM_AUN(1) = GAU(1)
        GWM_AUN(2) = GAU(2)
        GWM_ADL(1) = GAD(1)
        GWM_ADL(2) = GAD(2)
      CASE(ZZhad,WPZhad,WMZhad,
     &     WPZhadjj, WMZhadjj, ZZhadjj, WWZhad, ZZhadWP, ZZhadWM, ZZZhad, WPZhadJ, WMZhadJ)
        if (finalquarks(1).eq.93 .or. mod(abs(finalquarks(1)),2).eq.0) then         ! the mod-part also includes ID=94!
           ! set couplings for Z hadronic decay into uubar
           ! any modifications here also have to go into the relevant m2s-routines!
           GZ_ZF(1) = GZU(1)
           GZ_ZF(2) = GZU(2)
           GZ_AF(1) = GAU(1)
           GZ_AF(2) = GAU(2)
           Ztouu = .true.
        else
           ! set couplings for Z hadronic decay into ddbar
           ! any modifications here also have to go into the relevant m2s-routines!
           GZ_ZF(1) = GZD(1)
           GZ_ZF(2) = GZD(2)
           GZ_AF(1) = GAD(1)
           GZ_AF(2) = GAD(2)
           Ztodd = .true.
        endif
        GZ_ZUN(1) = GZU(1)
        GZ_ZUN(2) = GZU(2)
      END SELECT

      RETURN
      END 



      SUBROUTINE setZtouu

      implicit none

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"

      GZ_ZF(1) = GZU(1)
      GZ_ZF(2) = GZU(2)
      GZ_AF(1) = GAU(1)
      GZ_AF(2) = GAU(2)
      Ztouu = .true.
      Ztodd = .false.

      RETURN
      END 



      SUBROUTINE setZtodd

      implicit none

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/coupl_haddecay.inc"

      GZ_ZF(1) = GZD(1)
      GZ_ZF(2) = GZD(2)
      GZ_AF(1) = GAD(1)
      GZ_AF(2) = GAD(2)
      Ztouu = .false.
      Ztodd = .true.

      RETURN
      END 

